#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <errno.h>

/* siehe netdevice(7) */

int ifconfig(const char *ifname)
{
  int fd;
  int r;
  struct ifreq ifr;
  struct sockaddr_in sai;
  struct sockaddr_in netmask;

  memset(&sai, 0, sizeof(struct sockaddr_in));
  sai.sin_family = AF_INET;
  sai.sin_port = 0;
  sai.sin_addr.s_addr = inet_addr("10.0.5.1");

  memset(&netmask, 0, sizeof(struct sockaddr_in));
  netmask.sin_family = AF_INET;
  netmask.sin_port = 0;
  netmask.sin_addr.s_addr = inet_addr("255.255.255.0");

  strncpy(ifr.ifr_name,ifname,IFNAMSIZ);

  fd = socket(AF_INET,SOCK_DGRAM,0);
  if(fd <0) { perror("socket"); return -1; }
   
  memcpy((char *)&(ifr.ifr_addr),(char *)&sai,sizeof(struct sockaddr));
  r=ioctl(fd, SIOCSIFADDR,&ifr);
  if(r<0) { perror("ioctl(SIOCSIFADDR)"); }
  memcpy((char *)&(ifr.ifr_netmask),(char *)&netmask,sizeof(struct sockaddr));
  r=ioctl(fd,SIOCSIFNETMASK,&ifr); 
  if(r<0) { perror("ioctl(SIOCSNETMASK)"); }

  r=ioctl(fd, SIOCGIFFLAGS, &ifr);
  if(r<0) { perror("ioctl(SIOCGIFFLAGS)"); }
  ifr.ifr_flags |= IFF_UP | IFF_RUNNING;
  r=ioctl(fd, SIOCSIFFLAGS, &ifr);
  if(r<0) { perror("ioctl(SIOCSIFFLAGS)"); }
  close(fd);
  return 0;
}


int main(int argc,char **argv)
{
  const char *ifname;
  if(argc < 2)
  {
    fprintf(stderr,"Aufruf %s ifname\n",argv[0]);
    return -1;
  }
  ifname=argv[1];

  return ifconfig(ifname);
}
